<!DOCTYPE html>
<html lang="en">

<head>
    <title>View detail user</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body>
    <div class="container jumbotron w-50">
        <div class="row form-group">
            <div class="col-sm-12 text-center">
                <h3>Chi tiết User</h3>
                <a id="input-id"></a>
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-3">
                <label for="">Name:</label>
            </div>
            <div class="col-sm-9">
                <input id="input-name" type="text" class="form-control">
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-3">
                <label for="">User Name:</label>
            </div>
            <div class="col-sm-9">
                <input id="input-user-name" type="text" class="form-control">
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-3">
                <label for="">Email:</label>
            </div>
            <div class="col-sm-9">
                <input id="input-email" type="text" class="form-control">
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-3">
                <label for="">Address:</label>
            </div>
            <div class="col-sm-9">
                <div class="row form-group">
                    <div class="col-sm-2">
                        <label for="suite">Suite:</label>
                    </div>
                    <div class="col-sm-10">
                        <input id="input-suite" type="text" class="form-control">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-2">
                        <label for="street">Street:</label>
                    </div>
                    <div class="col-sm-10">
                        <input id="input-street" type="text" class="form-control">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-2">
                        <label for="city">City:</label>
                    </div>
                    <div class="col-sm-10">
                        <input id="input-city" type="text" class="form-control">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-2">
                        <label for="zipcode">Zipcode:</label>
                    </div>
                    <div class="col-sm-10">
                        <input id="input-zipcode" type="text" class="form-control">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-2">
                        <label for="geo">Geo:</label>
                    </div>
                    <div class="col-sm-10">
                        <div class="row form-group">
                            <div class="col-sm-2">
                                <label for="lat">Lat:</label>
                            </div>
                            <div class="col-sm-10">
                                <input id="input-lat" type="text" class="form-control">
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-2">
                                <label for="lng">Lng:</label>
                            </div>
                            <div class="col-sm-10">
                                <input id="input-lng" type="text" class="form-control">
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-3">
                <label for="">Phone:</label>
            </div>
            <div class="col-sm-9">
                <input id="input-phone" type="text" class="form-control">
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-3">
                <label for="">Website:</label>
            </div>
            <div class="col-sm-9">
                <input id="input-website" type="text" class="form-control">
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-3">
                <label for="company">Company:</label>
            </div>
            <div class="col-sm-9">
                <div class="row form-group">
                    <div class="col-sm-3">
                        <label for="companyName">Name:</label>
                    </div>
                    <div class="col-sm-9">
                        <input id="input-company-name" type="text" class="form-control">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-3">
                        <label for="catchphrase">Catch Phrase:</label>
                    </div>
                    <div class="col-sm-9">
                        <input id="input-catchphrase" type="text" class="form-control">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-3">
                        <label for="bs">Bs:</label>
                    </div>
                    <div class="col-sm-9">
                        <input id="input-bs" type="text" class="form-control">
                    </div>
                </div>
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-12" style="text-align: right;">
                <button id="btn-update" class="btn btn-primary w-25">Update</button>
                <button id="btnback" class="btn btn-success w-25">Hủy bỏ</button>
            </div>
        </div>
    </div>
    </div>
</body>
<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */

    const vBASE_URL = "https://jsonplaceholder.typicode.com/users/";
    var gEleName = $("#input-name");
    var gEleUserName = $("#input-user-name");
    var gEleEmail = $("#input-email");
    var gEleSuite = $("#input-suite");
    var gEleStreet = $("#input-street");
    var gEleCity = $("#input-city");
    var gEleZipcode = $("#input-zipcode");
    var gEleLat = $("#input-lat");
    var gEleLng = $("#input-lng");
    var gElePhone = $("#input-phone");
    var gEleWebsite = $("#input-website");
    var gEleCompanyName = $("#input-company-name");
    var gEleCatchphrase = $("#input-catchphrase");
    var gEleBs = $("#input-bs");

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

    $(document).ready(function () {
        onPageLoading();
    });
    $("#btnback").on("click", function () {
        const V_HOME_URL = "Task 35.10 -  Load All Users .html";
        window.location.href = V_HOME_URL;
    });
    $("#btn-update").on("click", function () {
        onBtnUpdateClick();
    });

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */

    // Hàm xử lý sự kiện load trang
    function onPageLoading() {
        // b1: thu thập dữ liệu
        var vUrlString = window.location.href;  // đường dẫn gọi đến trang
        console.log(vUrlString);
        var vUrl = new URL(vUrlString);
        var gUserId = vUrl.searchParams.get("id");
        console.log(gUserId);
        // b2: validate
        var vIsValue = validateData(gUserId);
        if (vIsValue) {
            // b3: call Api và hiển thị dữ liệu
            callApiGetDataForm(gUserId);
        }
    }

    // Hàm xử lí sự kiện update
    function onBtnUpdateClick() {
        // Đối tượng
        var vObject = {
            name: "",
            username: "",
            email: "",
            address: {
                suite: "",
                street: "",
                city: "",
                zipcode: "",
                geo: {
                    lat: "",
                    lng: "",
                }
            },
            phone: "",
            website: "",
            company: {
                name: "",
                catchPhrase: "",
                bs: ""
            }
        };
        // b1: thu thập dữ liệu
        getDataOnForm(vObject);
        // b2: validate
        var vValid = validateDataUser(vObject);
        if (vValid) {
            // b3: Call Api update
            calApiUpdateUser(vObject);
        }
    };

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/

    // Hàm kiểm tra dữ liệu
    function validateData(paramObject) {
        if (paramObject == "" || paramObject === null) {
            alert("Không có Id!!");
            window.location.href = "Task 35.10 -  Load All Users .html";
            return false;
        }
        return true;
    };

    // Hàm gọi Api lấy dữ liệu 
    function callApiGetDataForm(paramObject) {
        $.ajax({
            url: vBASE_URL + "/" + paramObject,
            type: "GET",
            dataType: "json",
            success: function (paramUserObj) {
                console.log(paramUserObj);
                // Hiển thị dữ liệu
                showDataOnForm(paramUserObj);
            },
            error: function (content) {
                alert(content.responseText);
            }
        });
    };

    // Hàm hiển thị dữ liệu
    function showDataOnForm(paramUserObj) {
        $("#input-name").val(paramUserObj.name);
        $("#input-user-name").val(paramUserObj.username);
        $("#input-email").val(paramUserObj.email);
        $("#input-suite").val(paramUserObj.address.suite);
        $("#input-street").val(paramUserObj.address.street);
        $("#input-city").val(paramUserObj.address.city);
        $("#input-zipcode").val(paramUserObj.address.zipcode);
        $("#input-lat").val(paramUserObj.address.geo.lat);
        $("#input-lng").val(paramUserObj.address.geo.lng);
        $("#input-phone").val(paramUserObj.phone);
        $("#input-website").val(paramUserObj.website);
        $("#input-company-name").val(paramUserObj.company.name);
        $("#input-catchphrase").val(paramUserObj.company.catchPhrase);
        $("#input-bs").val(paramUserObj.company.bs);
    };

    // Hàm thu thập dữ liệu
    function getDataOnForm(paramObject) {
        // debugger;
        paramObject.name = $.trim(gEleName.val());
        paramObject.username = $.trim(gEleUserName.val());
        paramObject.email = $.trim(gEleEmail.val());
        paramObject.address.suite = $.trim(gEleSuite.val());
        paramObject.address.street = $.trim(gEleStreet.val());
        paramObject.address.city = $.trim(gEleCity.val());
        paramObject.address.zipcode = $.trim(gEleZipcode.val());
        paramObject.address.geo.lat = $.trim(gEleLat.val());
        paramObject.address.geo.lng = $.trim(gEleLng.val());
        paramObject.phone = $.trim(gElePhone.val());
        paramObject.website = $.trim(gEleWebsite.val());
        paramObject.company.name = $.trim(gEleCompanyName.val());
        paramObject.company.catchPhrase = $.trim(gEleCatchphrase.val());
        paramObject.company.bs = $.trim(gEleBs.val());
    };

    // Hàm kiểm tra dữ liệu update
    function validateDataUser(paramObject) {
        // var vRegexEmail = /^[^\s@]+@[^\s@]+\.[^\s@]+$/;
        if (paramObject.name == "") {
            alert("Bạn chưa nhập Name!!");
            gEleName.focus();
            return false;
        }
        if (paramObject.username == "") {
            alert("Bạn chưa nhập User Name!!");
            gEleUserName.focus();
            return false;
        }
        if (paramObject.email == "") {
            alert("Bạn chưa nhập Email!!");
            gEleEmail.focus();
            return false;
        }
        // if (!vRegexEmail.test(paramObject.email)) {
        //     alert("Email nhập chưa hợp lệ!!");
        //     $("#input-email").focus();
        //     return false;
        // }
        if (paramObject.address.suite == "") {
            alert("Bạn chưa nhập suite!!");
            gEleSuite.focus();
            return false;
        }
        if (paramObject.address.street == "") {
            alert("Bạn chưa nhập street!!");
            gEleStreet.focus();
            return false;
        }
        if (paramObject.address.city == "") {
            alert("Bạn chưa nhập city!!");
            gEleCity.focus();
            return false;
        }
        if (paramObject.address.zipcode == "") {
            alert("Bạn chưa nhập zipcode!!");
            gEleZipcode.focus();
            return false;
        }
        if (paramObject.address.geo.lat == "") {
            alert("Bạn chưa nhập lat!!");
            gEleLat.focus();
            return false;
        }
        if (paramObject.address.geo.lng == "") {
            alert("Bạn chưa nhập lng!!");
            gEleLng.focus();
            return false;
        }
        if (paramObject.phone == "") {
            alert("Bạn chưa nhập phone!!");
            gElePhone.focus();
            return false;
        }
        if (paramObject.website == "") {
            alert("Bạn chưa nhập website!!");
            gEleWebsite.focus();
            return false;
        }
        if (paramObject.company.name == "") {
            alert("Bạn chưa nhập company name!!");
            gEleCompanyName.focus();
            return false;
        }
        if (paramObject.company.catchPhrase == "") {
            alert("Bạn chưa nhập catchPhrase!!");
            gEleCatchphrase.focus();
            return false;
        }
        if (paramObject.company.bs == "") {
            alert("Bạn chưa nhập bs!!");
            gEleBs.focus();
            return false;
        }
        return true;
    };

    // Hàm gọi Api update user
    function calApiUpdateUser(paramObject) {
        var vUserId = getCurrentUserId();
        $.ajax({
            url: vBASE_URL + vUserId,
            type: "PUT",
            data: JSON.stringify(paramObject),
            contentType: "application/json;charset=UTF-8",
            success: function (paramResponse) {
                // Thông báo cập nhật thành công
                alert("User ID:" + " " + paramResponse.id + "\n Cập nhật thông tin thành công!!")
                // Khi cập nhật thành công quay trở lại trang danh sách người dùng
                // window.location.href = "Task 35.10 -  Load All Users .html";
                console.log(JSON.stringify(paramResponse, true, 2));
            },
            error: function (ajaxContext) {
                alert(ajaxContext.responseText);
            }
        });
    };

    // Hàm  thu thập UserId đang gửi request hiện tại
    function getCurrentUserId() {
        var vId = null;
        var vUrl = new URL(window.location.href);
        vId = vUrl.searchParams.get("id");
        return vId;
    };
</script>

</html>